/**
 * Autogenerated by Avro
 * <p>
 * DO NOT EDIT DIRECTLY
 */
package com.dev.food.ordering.system.kafka.order.avro.model;

import org.apache.avro.message.BinaryMessageDecoder;
import org.apache.avro.message.BinaryMessageEncoder;
import org.apache.avro.message.SchemaStore;
import org.apache.avro.specific.SpecificData;

@org.apache.avro.specific.AvroGenerated
public class Product extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
    public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"Product\",\"namespace\":\"com.dev.food.ordering.system.kafka.order.avro.model\",\"fields\":[{\"name\":\"id\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"},\"logicalType\":\"uuid\"},{\"name\":\"quantity\",\"type\":\"int\"}]}");
    private static final long serialVersionUID = -5292045654081940115L;
    private static final SpecificData MODEL$ = new SpecificData();
    private static final BinaryMessageEncoder<Product> ENCODER =
            new BinaryMessageEncoder<Product>(MODEL$, SCHEMA$);
    private static final BinaryMessageDecoder<Product> DECODER =
            new BinaryMessageDecoder<Product>(MODEL$, SCHEMA$);
    @SuppressWarnings("unchecked")
    private static final org.apache.avro.io.DatumWriter<Product>
            WRITER$ = (org.apache.avro.io.DatumWriter<Product>) MODEL$.createDatumWriter(SCHEMA$);
    @SuppressWarnings("unchecked")
    private static final org.apache.avro.io.DatumReader<Product>
            READER$ = (org.apache.avro.io.DatumReader<Product>) MODEL$.createDatumReader(SCHEMA$);
    private java.lang.String id;
    private int quantity;

    /**
     * Default constructor.  Note that this does not initialize fields
     * to their default values from the schema.  If that is desired then
     * one should use <code>newBuilder()</code>.
     */
    public Product() {
    }

    /**
     * All-args constructor.
     *
     * @param id       The new value for id
     * @param quantity The new value for quantity
     */
    public Product(java.lang.String id, java.lang.Integer quantity) {
        this.id = id;
        this.quantity = quantity;
    }

    public static org.apache.avro.Schema getClassSchema() {
        return SCHEMA$;
    }

    /**
     * Return the BinaryMessageEncoder instance used by this class.
     *
     * @return the message encoder used by this class
     */
    public static BinaryMessageEncoder<Product> getEncoder() {
        return ENCODER;
    }

    /**
     * Return the BinaryMessageDecoder instance used by this class.
     *
     * @return the message decoder used by this class
     */
    public static BinaryMessageDecoder<Product> getDecoder() {
        return DECODER;
    }

    /**
     * Create a new BinaryMessageDecoder instance for this class that uses the specified {@link SchemaStore}.
     *
     * @param resolver a {@link SchemaStore} used to find schemas by fingerprint
     * @return a BinaryMessageDecoder instance for this class backed by the given SchemaStore
     */
    public static BinaryMessageDecoder<Product> createDecoder(SchemaStore resolver) {
        return new BinaryMessageDecoder<Product>(MODEL$, SCHEMA$, resolver);
    }

    /**
     * Deserializes a Product from a ByteBuffer.
     *
     * @param b a byte buffer holding serialized data for an instance of this class
     * @return a Product instance decoded from the given buffer
     * @throws java.io.IOException if the given bytes could not be deserialized into an instance of this class
     */
    public static Product fromByteBuffer(
            java.nio.ByteBuffer b) throws java.io.IOException {
        return DECODER.decode(b);
    }

    /**
     * Creates a new Product RecordBuilder.
     *
     * @return A new Product RecordBuilder
     */
    public static com.dev.food.ordering.system.kafka.order.avro.model.Product.Builder newBuilder() {
        return new com.dev.food.ordering.system.kafka.order.avro.model.Product.Builder();
    }

    /**
     * Creates a new Product RecordBuilder by copying an existing Builder.
     *
     * @param other The existing builder to copy.
     * @return A new Product RecordBuilder
     */
    public static com.dev.food.ordering.system.kafka.order.avro.model.Product.Builder newBuilder(com.dev.food.ordering.system.kafka.order.avro.model.Product.Builder other) {
        if (other == null) {
            return new com.dev.food.ordering.system.kafka.order.avro.model.Product.Builder();
        } else {
            return new com.dev.food.ordering.system.kafka.order.avro.model.Product.Builder(other);
        }
    }

    /**
     * Creates a new Product RecordBuilder by copying an existing Product instance.
     *
     * @param other The existing instance to copy.
     * @return A new Product RecordBuilder
     */
    public static com.dev.food.ordering.system.kafka.order.avro.model.Product.Builder newBuilder(com.dev.food.ordering.system.kafka.order.avro.model.Product other) {
        if (other == null) {
            return new com.dev.food.ordering.system.kafka.order.avro.model.Product.Builder();
        } else {
            return new com.dev.food.ordering.system.kafka.order.avro.model.Product.Builder(other);
        }
    }

    /**
     * Serializes this Product to a ByteBuffer.
     *
     * @return a buffer holding the serialized data for this instance
     * @throws java.io.IOException if this instance could not be serialized
     */
    public java.nio.ByteBuffer toByteBuffer() throws java.io.IOException {
        return ENCODER.encode(this);
    }

    public org.apache.avro.specific.SpecificData getSpecificData() {
        return MODEL$;
    }

    public org.apache.avro.Schema getSchema() {
        return SCHEMA$;
    }

    // Used by DatumWriter.  Applications should not call.
    public java.lang.Object get(int field$) {
        switch (field$) {
            case 0:
                return id;
            case 1:
                return quantity;
            default:
                throw new IndexOutOfBoundsException("Invalid index: " + field$);
        }
    }

    // Used by DatumReader.  Applications should not call.
    @SuppressWarnings(value = "unchecked")
    public void put(int field$, java.lang.Object value$) {
        switch (field$) {
            case 0:
                id = value$ != null ? value$.toString() : null;
                break;
            case 1:
                quantity = (java.lang.Integer) value$;
                break;
            default:
                throw new IndexOutOfBoundsException("Invalid index: " + field$);
        }
    }

    /**
     * Gets the value of the 'id' field.
     *
     * @return The value of the 'id' field.
     */
    public java.lang.String getId() {
        return id;
    }

    /**
     * Sets the value of the 'id' field.
     *
     * @param value the value to set.
     */
    public void setId(java.lang.String value) {
        this.id = value;
    }

    /**
     * Gets the value of the 'quantity' field.
     *
     * @return The value of the 'quantity' field.
     */
    public int getQuantity() {
        return quantity;
    }

    /**
     * Sets the value of the 'quantity' field.
     *
     * @param value the value to set.
     */
    public void setQuantity(int value) {
        this.quantity = value;
    }

    @Override
    public void writeExternal(java.io.ObjectOutput out)
            throws java.io.IOException {
        WRITER$.write(this, SpecificData.getEncoder(out));
    }

    @Override
    public void readExternal(java.io.ObjectInput in)
            throws java.io.IOException {
        READER$.read(this, SpecificData.getDecoder(in));
    }

    @Override
    protected boolean hasCustomCoders() {
        return true;
    }

    @Override
    public void customEncode(org.apache.avro.io.Encoder out)
            throws java.io.IOException {
        out.writeString(this.id);

        out.writeInt(this.quantity);

    }

    @Override
    public void customDecode(org.apache.avro.io.ResolvingDecoder in)
            throws java.io.IOException {
        org.apache.avro.Schema.Field[] fieldOrder = in.readFieldOrderIfDiff();
        if (fieldOrder == null) {
            this.id = in.readString();

            this.quantity = in.readInt();

        } else {
            for (int i = 0; i < 2; i++) {
                switch (fieldOrder[i].pos()) {
                    case 0:
                        this.id = in.readString();
                        break;

                    case 1:
                        this.quantity = in.readInt();
                        break;

                    default:
                        throw new java.io.IOException("Corrupt ResolvingDecoder.");
                }
            }
        }
    }

    /**
     * RecordBuilder for Product instances.
     */
    @org.apache.avro.specific.AvroGenerated
    public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<Product>
            implements org.apache.avro.data.RecordBuilder<Product> {

        private java.lang.String id;
        private int quantity;

        /**
         * Creates a new Builder
         */
        private Builder() {
            super(SCHEMA$, MODEL$);
        }

        /**
         * Creates a Builder by copying an existing Builder.
         *
         * @param other The existing Builder to copy.
         */
        private Builder(com.dev.food.ordering.system.kafka.order.avro.model.Product.Builder other) {
            super(other);
            if (isValidValue(fields()[0], other.id)) {
                this.id = data().deepCopy(fields()[0].schema(), other.id);
                fieldSetFlags()[0] = other.fieldSetFlags()[0];
            }
            if (isValidValue(fields()[1], other.quantity)) {
                this.quantity = data().deepCopy(fields()[1].schema(), other.quantity);
                fieldSetFlags()[1] = other.fieldSetFlags()[1];
            }
        }

        /**
         * Creates a Builder by copying an existing Product instance
         *
         * @param other The existing instance to copy.
         */
        private Builder(com.dev.food.ordering.system.kafka.order.avro.model.Product other) {
            super(SCHEMA$, MODEL$);
            if (isValidValue(fields()[0], other.id)) {
                this.id = data().deepCopy(fields()[0].schema(), other.id);
                fieldSetFlags()[0] = true;
            }
            if (isValidValue(fields()[1], other.quantity)) {
                this.quantity = data().deepCopy(fields()[1].schema(), other.quantity);
                fieldSetFlags()[1] = true;
            }
        }

        /**
         * Gets the value of the 'id' field.
         *
         * @return The value.
         */
        public java.lang.String getId() {
            return id;
        }


        /**
         * Sets the value of the 'id' field.
         *
         * @param value The value of 'id'.
         * @return This builder.
         */
        public com.dev.food.ordering.system.kafka.order.avro.model.Product.Builder setId(java.lang.String value) {
            validate(fields()[0], value);
            this.id = value;
            fieldSetFlags()[0] = true;
            return this;
        }

        /**
         * Checks whether the 'id' field has been set.
         *
         * @return True if the 'id' field has been set, false otherwise.
         */
        public boolean hasId() {
            return fieldSetFlags()[0];
        }


        /**
         * Clears the value of the 'id' field.
         *
         * @return This builder.
         */
        public com.dev.food.ordering.system.kafka.order.avro.model.Product.Builder clearId() {
            id = null;
            fieldSetFlags()[0] = false;
            return this;
        }

        /**
         * Gets the value of the 'quantity' field.
         *
         * @return The value.
         */
        public int getQuantity() {
            return quantity;
        }


        /**
         * Sets the value of the 'quantity' field.
         *
         * @param value The value of 'quantity'.
         * @return This builder.
         */
        public com.dev.food.ordering.system.kafka.order.avro.model.Product.Builder setQuantity(int value) {
            validate(fields()[1], value);
            this.quantity = value;
            fieldSetFlags()[1] = true;
            return this;
        }

        /**
         * Checks whether the 'quantity' field has been set.
         *
         * @return True if the 'quantity' field has been set, false otherwise.
         */
        public boolean hasQuantity() {
            return fieldSetFlags()[1];
        }


        /**
         * Clears the value of the 'quantity' field.
         *
         * @return This builder.
         */
        public com.dev.food.ordering.system.kafka.order.avro.model.Product.Builder clearQuantity() {
            fieldSetFlags()[1] = false;
            return this;
        }

        @Override
        @SuppressWarnings("unchecked")
        public Product build() {
            try {
                Product record = new Product();
                record.id = fieldSetFlags()[0] ? this.id : (java.lang.String) defaultValue(fields()[0]);
                record.quantity = fieldSetFlags()[1] ? this.quantity : (java.lang.Integer) defaultValue(fields()[1]);
                return record;
            } catch (org.apache.avro.AvroMissingFieldException e) {
                throw e;
            } catch (java.lang.Exception e) {
                throw new org.apache.avro.AvroRuntimeException(e);
            }
        }
    }
}










